VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CreditCard"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Implements IManage
Public CardNumber As Integer
Attribute CardNumber.VB_VarUserMemId = 0
Attribute CardNumber.VB_VarHelpID = 3
Public ExpireDate As Date
Private msngAmount As Single
Private sCreditLimit As Single

Public Event Status(ByVal StatusText As String)

Public Property Get PurchaseAmount() As Single
Attribute PurchaseAmount.VB_Description = "Credit card purchase amount. Will produce a run-time error iif set to less than or equal to zero."
Attribute PurchaseAmount.VB_HelpID = 2
    PurchaseAmount = msngAmount
End Property

Public Property Let PurchaseAmount(ByVal sngAmount As Single)
    If sngAmount > 0 Then
        msngAmount = sngAmount 'save in private module variable
    Else 'purchase less than zero is invalid
        'msngAmount = 0
        Err.Raise vbObjectError + 1000, _
            "Lab.CreditCard", _
            "Purchase amount must be greater than zero."
    End If
End Property

Public Function Approve() As Boolean
Attribute Approve.VB_Description = "Method to approve credit card purchase."
Attribute Approve.VB_HelpID = 1
    Dim sngEndTime As Single
    
    RaiseEvent Status("Dialing bank...")
    'simulate delay dialing bank
    sngEndTime = Timer + 2
    Do While Timer < sngEndTime
        DoEvents    ' Yield to other processes.
    Loop
    
    RaiseEvent Status("Processing card...")
    'simulate delay processing card
    sngEndTime = Timer + 2
    Do While Timer < sngEndTime
        DoEvents    ' Yield to other processes.
    Loop
    
    
    'dummy logic for approving credit card
    If msngAmount < sCreditLimit And ExpireDate > Now() Then
        Approve = True
    Else
        Approve = False
    End If
End Function

Private Sub Class_Initialize()
    Debug.Print "class initialize"
    ' Initialize the credit limit.
    sCreditLimit = 1000
End Sub

' The following two functions implement the IManage interface.
' When a client gets this interface, it has the ability to change
' the credit limit being used.
' More realistically, the creditcard component would be querying a
' database for customer credit limits and this interface would allow
' authorized individuals to change those customer limits.
Public Property Get IManage_CreditLimit() As Single
  IManage_CreditLimit = sCreditLimit
End Property

Public Property Let IManage_CreditLimit(ByVal sNewLimit As Single)
  ' Set the new credit limit. Only change it if the new limit is
  ' greater than zero.
  If sNewLimit > 0 Then
    sCreditLimit = sNewLimit
  End If
End Property
