VERSION 5.00
Object = "{48E59290-9880-11CF-9754-00AA00C00908}#1.0#0"; "MSINET.OCX"
Begin VB.Form frmFTPCopy 
   Caption         =   "FTP Download"
   ClientHeight    =   2415
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   104.545
   ScaleMode       =   0  'User
   ScaleWidth      =   100
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   495
      Left            =   1920
      TabIndex        =   0
      Top             =   1620
      Width           =   1215
   End
   Begin InetCtlsObjects.Inet Inet1 
      Left            =   4020
      Top             =   1740
      _ExtentX        =   1005
      _ExtentY        =   1005
   End
   Begin VB.Label lblOperation 
      Caption         =   "Label1"
      Height          =   315
      Left            =   150
      TabIndex        =   1
      Top             =   180
      Width           =   4425
   End
   Begin VB.Image imgCopying 
      Height          =   480
      Left            =   2310
      Picture         =   "frmFTPCopy.frx":0000
      Top             =   840
      Visible         =   0   'False
      Width           =   480
   End
   Begin VB.Image imgDestination 
      Height          =   480
      Left            =   3744
      Picture         =   "frmFTPCopy.frx":0442
      Top             =   1155
      Width           =   480
   End
   Begin VB.Image imgSource 
      Height          =   480
      Left            =   468
      Picture         =   "frmFTPCopy.frx":0884
      Top             =   1155
      Width           =   480
   End
End
Attribute VB_Name = "frmFTPCopy"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' This demonstrates the ability to had custom events to a form.
' These events notify the underlying class as to the state of
' the operation.
Public Event CopyCancelled()
Public Event CopyCompleted()
Public Event CopyError(ByVal respCode As Integer, ByVal respInfo As String)

' Although the WinINet control provides state changes (State_Change
' event) during a download, it is not steady enough to provide a
' 'flying' icon. So we use the GlobalTimer component and it's
' TimerEvent event to accomplish this.
Private WithEvents gTimer As CTimer
Attribute gTimer.VB_VarHelpID = -1

' Variable and values for flying the icon.
Private FlyingImageX As Single
Const interval  As Single = 5
Const FlyingImageStart  As Single = 20
Const FlyingImageEnd  As Single = 80

Private Sub cmdCancel_Click()
  ' If the user cancels the copy operation, do the necessary cleanup.
  Inet1.Cancel              ' Cancel the WinINet FTP download
  Unload Me                 ' Unload this form
  RaiseEvent CopyCancelled  ' Notify the underlying class
End Sub

Private Sub Form_Load()
  ' Create the timer object for flying the icon
  Set gTimer = New CTimer
End Sub

Private Sub gTimer_TimerEvent()
  ' Fly the icon
  FlyImage
End Sub

Private Sub Inet1_StateChanged(ByVal State As Integer)
  Select Case State
  Case icConnected
    ' Setup flying image. Here we fly the icon once for initialization before
    ' making it visible.
    FlyingImageX = FlyingImageStart
    FlyImage
    imgCopying.Visible = True
    
    ' Begin the timer for flying the image
    gTimer.StartTimer 200
  Case icResponseCompleted
    'Debug.Print "State: Response Completed"
    gTimer.StopTimer
    'bResponseCompleted = True
    imgCopying.Visible = False
    Unload Me
    RaiseEvent CopyCompleted
  Case icError
    gTimer.StopTimer
    Inet1.Cancel
    Unload Me
    RaiseEvent CopyError(Inet1.ResponseCode, Inet1.ResponseInfo)
  End Select
End Sub

Public Function BeginCopy(ByVal URL As String, ByVal Source As String, _
  ByVal Destination As String) As Boolean
  On Error GoTo ErrHandler
  Dim sOperation As String
  BeginCopy = True
  
  ' Display the source and destination on the form.
  lblOperation = "Copying """ & Source & """ to """ & Destination & """"
  
  Me.Show
  
  ' Ensure that the URL has an FTP header. This is a simple check and
  ' should be made much more exhaustive.
  If UCase$(Left$(URL, 6)) <> "FTP://" Then
    URL = "FTP://" & URL
  End If
  
  ' Setup INet1 control for file copy
  Inet1.AccessType = icUseDefault   ' Use the default setting for Proxy server
  sOperation = "" & "Get " & Source & " " & Destination & ""
  Inet1.Execute URL, sOperation
  While Inet1.StillExecuting
    DoEvents
  Wend
  Exit Function
ErrHandler:
  BeginCopy = False
  Unload Me
  ' Pass the error on to the calling application.
  Err.Raise Err.Number, Err.Source, Err.Description, Err.HelpFilem, Err.HelpContext
End Function

' This function calculates the y position of the flying icon given
' the static X position, generating a nice parabolic path.
Private Function FlyingImageY() As Single
  FlyingImageY = 1 / 36 * (FlyingImageX - 50) * (FlyingImageX - 50) + 20
  FlyingImageX = FlyingImageX + interval
  If FlyingImageX > FlyingImageEnd Then FlyingImageX = FlyingImageStart
End Function

Private Sub FlyImage()
  imgCopying.Move FlyingImageX, FlyingImageY
End Sub
