VERSION 5.00
Object = "{48E59290-9880-11CF-9754-00AA00C00908}#1.0#0"; "MSINET.OCX"
Begin VB.Form frmFTPGetFileName 
   Caption         =   "Form1"
   ClientHeight    =   3690
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4785
   LinkTopic       =   "Form1"
   ScaleHeight     =   3690
   ScaleWidth      =   4785
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   495
      Left            =   2483
      TabIndex        =   2
      Top             =   3120
      Width           =   1215
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "&OK"
      Default         =   -1  'True
      Height          =   495
      Left            =   983
      TabIndex        =   1
      Top             =   3120
      Width           =   1095
   End
   Begin VB.ListBox lstFiles 
      Height          =   2985
      ItemData        =   "frmFTPGetFileName.frx":0000
      Left            =   60
      List            =   "frmFTPGetFileName.frx":0002
      TabIndex        =   0
      Top             =   0
      Width           =   4635
   End
   Begin InetCtlsObjects.Inet Inet1 
      Left            =   3720
      Top             =   3960
      _ExtentX        =   1005
      _ExtentY        =   1005
   End
End
Attribute VB_Name = "frmFTPGetFileName"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
  
Public Event FileGetCompleted(ByVal sFileName As String)
Public Event FileGetCancelled()
Public Event FileGetError(ByVal respCode As Integer, _
                          ByVal respInfo As String)

Private curState As Integer
Private strDir As String

Private Sub cmdCancel_Click()
  If Inet1.StillExecuting Then Inet1.Cancel
  RaiseEvent FileGetCancelled
  Unload Me
End Sub

Private Sub cmdOK_Click()
  ' Send the filename in the FileGetCompleted event
  RaiseEvent FileGetCompleted(lstFiles.List(lstFiles.ListIndex))
  Unload Me
End Sub

Private Sub Form_Resize()
  ' Resize the file listbox to the new form size
  lstFiles.Move 0, 0, ScaleWidth, ScaleHeight - 2 * cmdOK.Height
End Sub

Public Sub BeginGetFile(ByVal URL As String)
Attribute BeginGetFile.VB_MemberFlags = "40"
  Dim strFile As String
  Dim nextPos As Integer
  
  On Error GoTo Err_Handler
  
  ' Initialize the current search position in the directory
  ' listing string.
  nextPos = 1
  
  ' Get a directory listing from the server. The list will be a series
  ' of file names separated by a CR/LF pair and returned in the string
  ' "strDir".
  If Not GetDirectoryListing(URL) Then
    Err.Raise vbObjectError + 1, "frmGetFileName", _
      "FTP DIR command of " & URL & " was unsuccessful."
  End If
  
  ' Extract each filename from the list and add it to the file listbox.
  ' Note that here you are only dealing with the root directory of
  ' FTP server. One enhancement would be to walk the directory tree of
  ' the FTP server and display it in a TreeView control.
  lstFiles.Clear
  Do While GetNextItem(strFile, nextPos)
    If Right$(strFile, 1) <> "/" Then
      lstFiles.AddItem strFile
    End If
  Loop
  ' Set the initial selection to the first entry.
  lstFiles.ListIndex = 0
  
  ' Show the form
  Me.Show
  Exit Sub
Err_Handler:
  MsgBox Err.Description
End Sub

Private Function GetDirectoryListing(ByVal URL As String) As Boolean
  On Error GoTo ErrHandler
  Dim s As String
  
  ' Execute an FTP asynchronous DIR command
  Inet1.Execute URL, "DIR"
  Do While Inet1.StillExecuting
    DoEvents
  Loop
  GetDirectoryListing = (curState <> icError)
  Exit Function
ErrHandler:
  GetDirectoryListing = False
End Function

Private Function GetNextItem(ByRef s As String, _
                             ByRef nextPos As Integer) As Boolean
  Dim pos As Integer
  GetNextItem = False
  
  ' Find the next entry. This is done by simply checking for a CR. We
  ' assume that all entries are separated by the CR/LF pair so we
  ' add 2 to increment from the CR to the beginning of the next filename.
  pos = InStr(nextPos, strDir, vbCr)
  If pos > 0 And (pos - nextPos) > 0 Then
    s = Mid$(strDir, nextPos, pos - nextPos)
    nextPos = pos + 2
    GetNextItem = True
  End If
End Function

Private Sub Inet1_StateChanged(ByVal State As Integer)
  Dim s As String
  
  On Error GoTo Err_Handler
  Select Case State
  Case icError
    RaiseEvent FileGetError(Inet1.ResponseCode, Inet1.ResponseInfo)
    Inet1.Cancel
    Unload Me
  Case icResponseCompleted
    ' Transfer the FTP data into a local string. To transfer all of the
    ' data, call "GetChunk" repeatedly until it returns a NULL string.
    s = Inet1.GetChunk(1024)
    If Len(s) = 0 Then
      Exit Sub
    End If
    Do While Len(s) > 0
      strDir = strDir & s
      s = Inet1.GetChunk(1024)
    Loop
    ' Ensure that the string ends in a carriage return/linefeed.
    strDir = strDir & vbCrLf
  End Select
  curState = State
  Exit Sub
Err_Handler:
  MsgBox Err.Description
End Sub
